package edu.swarthmore.cs.cs71.lightsout.model.lightsout.gui;

import edu.swarthmore.cs.cs71.lightsout.model.lightsout.model.LightsOutModel;
import edu.swarthmore.cs.cs71.lightsout.model.lightsout.model.LightsOutModelImpl;
import javafx.application.Application;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.geometry.Pos;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.layout.GridPane;
import javafx.scene.layout.VBox;
import javafx.scene.paint.Color;
import javafx.scene.shape.Rectangle;
import javafx.scene.shape.Shape;
import javafx.stage.Stage;

import java.util.ArrayList;
import java.util.List;

public class LightsOutApplication extends Application {
    @Override
    public void start(Stage stage) throws Exception {
//        Button button1 = new Button("Push me!");
//        Button button2 = new Button("No, push me!");
//        button1.setOnAction(actionEvent -> System.out.println("Hi!"));
//
//        VBox vbox = new VBox();
//        vbox.getChildren().addAll(button1, button2);
//        vbox.setAlignment(Pos.CENTER);
        LightsOutModel model = new LightsOutModelImpl();

        GridPane gridPane = new GridPane();

        List<Shape> squares = new ArrayList<>();
        for (int y = 0; y< LightsOutModel.BOARD_SIZE; y++) {
            for (int x = 0; x< LightsOutModel.BOARD_SIZE; x++) {
                Color color;
                if (model.getSpaceState(x,y)) {
                    color = Color.BLACK;
                } else {
                    color = Color.WHITE;
                }
                final Shape s = new Rectangle(200,200, color);
                squares.add(s);
                gridPane.add(s, x, y);
                final int sx = x;
                final int sy = y;
                s.setOnMouseClicked(mouseEvent -> model.toggleSpace(sx,sy));
                model.addListener((xm, ym) -> {
                    if (xm == sx && ym == sy) {
                        Color color2;
                        if (model.getSpaceState(xm,ym)) {
                            color2 = Color.BLACK;
                        } else {
                            color2 = Color.WHITE;
                        }
                        s.setFill(color2);
                    }
                });
            }
        }

        VBox vbox = new VBox();
        vbox.getChildren().add(gridPane);

        Scene scene = new Scene(vbox);
        stage.setScene(scene);
        stage.sizeToScene();
        stage.show();
    }
}